Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3298)
@@ -1240,218 +1132,864 @@
 ! Description:
 ! ------------
-!> Subroutine for averaging 3D data of chemical species. Due to the fact that 
-!> the averaged chem arrays are allocated in chem_init, no if-query concerning
-!> the allocation is required (in any mode). Attention: If you just specify an 
-!> averaged output quantity in the _p3dr file during restarts the first output
-!> includes the time between the beginning of the restart run and the first
-!> output time (not necessarily the whole averaging_interval you have 
-!> specified in your _p3d/_p3dr file )
-!------------------------------------------------------------------------------!
-
-    SUBROUTINE chem_3d_data_averaging ( mode, variable )
-
-    USE control_parameters
-
-    USE indices
-
-    USE kinds
-
-    USE surface_mod,                                                         &
-        ONLY: surf_def_h, surf_lsm_h, surf_usm_h   
-  
-    IMPLICIT NONE
- 
-    CHARACTER (LEN=*) ::  mode    !< 
-    CHARACTER (LEN=*) :: variable !< 
- 
-    LOGICAL      ::  match_def !< flag indicating natural-type surface
-    LOGICAL      ::  match_lsm !< flag indicating natural-type surface
-    LOGICAL      ::  match_usm !< flag indicating urban-type surface
-
-    INTEGER(iwp) ::  i                  !< grid index x direction
-    INTEGER(iwp) ::  j                  !< grid index y direction
-    INTEGER(iwp) ::  k                  !< grid index z direction
-    INTEGER(iwp) ::  m                  !< running index surface type
-    INTEGER(iwp) :: lsp                 !< running index for chem spcs
-  
-    IF ( mode == 'allocate' )  THEN
-       DO lsp = 1, nspec
-          IF (TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-             chem_species(lsp)%conc_av = 0.0_wp
+!> Subroutine defining mask output variables for chemical species
+!------------------------------------------------------------------------------!
+    
+    SUBROUTINE chem_data_output_mask( av, variable, found, local_pf )
+    
+       USE control_parameters
+       USE indices
+       USE kinds
+       USE pegrid,             ONLY: myid, threads_per_task
+
+
+       IMPLICIT NONE
+
+       CHARACTER (LEN=*)::  variable    !< 
+       INTEGER(iwp)     ::  av          !< flag to control data output of instantaneous or time-averaged data
+       LOGICAL          ::  found       !< 
+       REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  &
+                 local_pf   !< 
+
+
+       !-- local variables.
+       CHARACTER(len=16)    ::  spec_name
+       INTEGER(iwp) ::  lsp
+       INTEGER(iwp) ::  i               !< grid index along x-direction
+       INTEGER(iwp) ::  j               !< grid index along y-direction
+       INTEGER(iwp) ::  k               !< grid index along z-direction
+       found = .TRUE.
+
+       spec_name = TRIM( variable(4:) )
+   !av == 0
+
+       DO lsp=1,nspec
+          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name) )               THEN             
+
+                IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM(variable)  // &
+                                                          TRIM(chem_species(lsp)%name)       
+             IF (av == 0) THEN
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2) 
+                      DO  k = 1, mask_size(mid,3) 
+                          local_pf(i,j,k) = chem_species(lsp)%conc(mask_k(mid,k),                                    &
+                                              mask_j(mid,j), mask_i(mid,i))
+                      ENDDO
+                   ENDDO
+                ENDDO
+           
+             ELSE
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k =  1, mask_size_l(mid,3)
+                          local_pf(i,j,k) = chem_species(lsp)%conc_av(mask_k(mid,k),                &
+                                             mask_j(mid,j), mask_i(mid,i))
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+             found = .FALSE.
           ENDIF
        ENDDO
 
-    ELSEIF ( mode == 'sum' )  THEN
-   
+       RETURN
+     
+    END SUBROUTINE chem_data_output_mask      
+
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining appropriate grid for netcdf variables.
+!> It is called out from subroutine netcdf.
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
+
+       IMPLICIT NONE
+
+       CHARACTER (LEN=*), INTENT(IN)  ::  var          !<
+       LOGICAL, INTENT(OUT)           ::  found        !<
+       CHARACTER (LEN=*), INTENT(OUT) ::  grid_x       !<
+       CHARACTER (LEN=*), INTENT(OUT) ::  grid_y       !<
+       CHARACTER (LEN=*), INTENT(OUT) ::  grid_z       !<
+
+       found  = .TRUE.
+
+       IF (var(1:3) == 'kc_')   THEN                   !< always the same grid for chemistry variables
+          grid_x = 'x'
+          grid_y = 'y'
+          grid_z = 'zu'                             
+       ELSE
+          found  = .FALSE.
+          grid_x = 'none'
+          grid_y = 'none'
+          grid_z = 'none'
+       ENDIF
+
+
+    END SUBROUTINE chem_define_netcdf_grid
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining header output for chemistry model
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_header ( io )
+       
+       IMPLICIT NONE 
+ 
+       INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
+       INTEGER(iwp)             :: lsp            !< running index for chem spcs
+       INTEGER(iwp)             :: cs_fixed 
+       CHARACTER (LEN=80)       :: docsflux_chr
+       CHARACTER (LEN=80)       :: docsinit_chr
+
+!
+!--    Write chemistry model  header
+       WRITE( io, 1 )
+
+!--    Gasphase reaction status
+       IF ( chem_gasphase_on )  THEN 
+          WRITE( io, 2 )
+       ELSE
+          WRITE( io, 3 )
+       ENDIF
+
+!      Chemistry time-step
+       WRITE ( io, 4 ) cs_time_step
+
+!--    Emission mode info
+       IF ( mode_emis == "DEFAULT" )  THEN 
+          WRITE( io, 5 ) 
+       ELSEIF ( mode_emis == "PARAMETERIZED" )  THEN 
+          WRITE( io, 6 )
+       ELSEIF ( mode_emis == "PRE-PROCESSED" )  THEN 
+          WRITE( io, 7 )
+       ENDIF 
+
+!--    Photolysis scheme info
+       IF ( photolysis_scheme == "simple" )      THEN
+          WRITE( io, 8 ) 
+       ELSEIF (photolysis_scheme == "conastant" ) THEN
+          WRITE( io, 9 )
+       ENDIF
+ 
+ !--   Emission flux info
+       lsp = 1
+       docsflux_chr ='Chemical species for surface emission flux: ' 
+       DO WHILE ( surface_csflux_name(lsp) /= 'novalue' )
+          docsflux_chr = TRIM( docsflux_chr ) // ' ' // TRIM( surface_csflux_name(lsp) ) // ','  
+          IF ( LEN_TRIM( docsflux_chr ) >= 75 )  THEN
+           WRITE ( io, 10 )  docsflux_chr
+           docsflux_chr = '       '
+          ENDIF
+          lsp = lsp + 1
+       ENDDO
+ 
+       IF ( docsflux_chr /= '' )  THEN
+          WRITE ( io, 10 )  docsflux_chr
+       ENDIF
+
+
+!--    initializatoin of Surface and profile chemical species
+
+       lsp = 1
+       docsinit_chr ='Chemical species for initial surface and profile emissions: ' 
+       DO WHILE ( cs_name(lsp) /= 'novalue' )
+          docsinit_chr = TRIM( docsinit_chr ) // ' ' // TRIM( cs_name(lsp) ) // ','  
+          IF ( LEN_TRIM( docsinit_chr ) >= 75 )  THEN
+           WRITE ( io, 11 )  docsinit_chr
+           docsinit_chr = '       '
+          ENDIF
+          lsp = lsp + 1
+       ENDDO
+ 
+       IF ( docsinit_chr /= '' )  THEN
+          WRITE ( io, 11 )  docsinit_chr
+       ENDIF
+
+!--    number of variable and fix chemical species and number of reactions
+       cs_fixed = nspec - nvar
+       WRITE ( io, * ) '   --> Chemical species, variable: ', nvar
+       WRITE ( io, * ) '   --> Chemical species, fixed   : ', cs_fixed
+       WRITE ( io, * ) '   --> Total number of reactions : ', nreact
+
+
+1   FORMAT (//' Chemistry model information:'/                                  &
+              ' ----------------------------'/)
+2   FORMAT ('    --> Chemical reactions are turned on')
+3   FORMAT ('    --> Chemical reactions are turned off')
+4   FORMAT ('    --> Time-step for chemical species: ',F6.2, ' s')
+5   FORMAT ('    --> Emission mode = DEFAULT ')
+6   FORMAT ('    --> Emission mode = PARAMETERIZED ')
+7   FORMAT ('    --> Emission mode = PRE-PROCESSED ')
+8   FORMAT ('    --> Photolysis scheme used =  simple ')
+9   FORMAT ('    --> Photolysis scheme used =  constant ')
+10  FORMAT (/'    ',A)  
+11  FORMAT (/'    ',A) 
+!
+!
+    END SUBROUTINE chem_header
+
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine initializating chemistry_model_mod
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_init
+
+       USE control_parameters,                                                  &
+          ONLY: message_string, io_blocks, io_group, turbulent_inflow
+       USE arrays_3d,                                                           &
+           ONLY: mean_inflow_profiles
+       USE pegrid
+
+       IMPLICIT   none
+   !-- local variables
+       INTEGER                 :: i,j               !< running index for for horiz numerical grid points
+       INTEGER                 :: lsp               !< running index for chem spcs
+       INTEGER                 :: lpr_lev           !< running index for chem spcs profile level
+!
+!-- NOPOINTER version not implemented yet
+! #if defined( __nopointer )
+!     message_string = 'The chemistry module only runs with POINTER version'
+!     CALL message( 'chemistry_model_mod', 'CM0001', 1, 2, 0, 6, 0 )      
+! #endif
+!
+!-- Allocate memory for chemical species
+       ALLOCATE( chem_species(nspec) )
+       ALLOCATE( spec_conc_1 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
+       ALLOCATE( spec_conc_2 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
+       ALLOCATE( spec_conc_3 (nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) )
+       ALLOCATE( spec_conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nspec) ) 
+       ALLOCATE( phot_frequen(nphot) ) 
+       ALLOCATE( freq_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nphot) )
+       ALLOCATE( bc_cs_t_val(nspec) )
+!
+!-- Initialize arrays
+       spec_conc_1 (:,:,:,:) = 0.0_wp
+       spec_conc_2 (:,:,:,:) = 0.0_wp
+       spec_conc_3 (:,:,:,:) = 0.0_wp
+       spec_conc_av(:,:,:,:) = 0.0_wp
+
+
        DO lsp = 1, nspec
-          IF (TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                       chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) + &
-                                                          chem_species(lsp)%conc(k,j,i)
+          chem_species(lsp)%name    = spc_names(lsp)
+
+          chem_species(lsp)%conc   (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_1 (:,:,:,lsp)
+          chem_species(lsp)%conc_p (nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_2 (:,:,:,lsp)
+          chem_species(lsp)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_3 (:,:,:,lsp)
+          chem_species(lsp)%conc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg)       => spec_conc_av(:,:,:,lsp)     
+
+          ALLOCATE (chem_species(lsp)%cssws_av(nysg:nyng,nxlg:nxrg))                   
+          chem_species(lsp)%cssws_av    = 0.0_wp
+!
+!--       The following block can be useful when emission module is not applied. &
+!--       if emission module is applied the following block will be overwritten.
+          ALLOCATE (chem_species(lsp)%flux_s_cs(nzb+1:nzt,0:threads_per_task-1))   
+          ALLOCATE (chem_species(lsp)%diss_s_cs(nzb+1:nzt,0:threads_per_task-1))   
+          ALLOCATE (chem_species(lsp)%flux_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1)) 
+          ALLOCATE (chem_species(lsp)%diss_l_cs(nzb+1:nzt,nys:nyn,0:threads_per_task-1))   
+          chem_species(lsp)%flux_s_cs = 0.0_wp                                     
+          chem_species(lsp)%flux_l_cs = 0.0_wp                                     
+          chem_species(lsp)%diss_s_cs = 0.0_wp                                      
+          chem_species(lsp)%diss_l_cs = 0.0_wp                                     
+!
+!--   Allocate memory for initial concentration profiles
+!--   (concentration values come from namelist)
+!--   (@todo (FK): Because of this, chem_init is called in palm before
+!--               check_parameters, since conc_pr_init is used there.
+!--               We have to find another solution since chem_init should
+!--               eventually be called from init_3d_model!!)
+          ALLOCATE ( chem_species(lsp)%conc_pr_init(0:nz+1) )
+          chem_species(lsp)%conc_pr_init(:) = 0.0_wp
+
+       ENDDO
+
+!
+!--    Initial concentration of profiles is prescribed by parameters cs_profile
+!--    and cs_heights in the namelist &chemistry_parameters
+       CALL chem_init_profiles      
+            
+            
+!
+!-- Initialize model variables
+
+
+       IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.            &
+            TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
+
+
+!--    First model run of a possible job queue.
+!--    Initial profiles of the variables must be computed.
+          IF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
+            CALL location_message( 'initializing with 1D chemistry model profiles', .FALSE. )
+!
+!--        Transfer initial profiles to the arrays of the 3D model
+             DO lsp = 1, nspec
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO lpr_lev = 1, nz + 1
+                         chem_species(lsp)%conc(lpr_lev,j,i) = chem_species(lsp)%conc_pr_init(lpr_lev)
+                      ENDDO
+                   ENDDO
+                ENDDO   
+             ENDDO
+          
+          ELSEIF ( INDEX(initializing_actions, 'set_constant_profiles') /= 0 )    &
+          THEN
+             CALL location_message( 'initializing with constant chemistry profiles', .FALSE. )
+
+             DO lsp = 1, nspec 
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      chem_species(lsp)%conc(:,j,i) = chem_species(lsp)%conc_pr_init    
                    ENDDO
                 ENDDO
              ENDDO
-          ELSEIF ( TRIM(variable(4:)) == TRIM('cssws*') )        THEN
+
+          ENDIF
+
+!
+!--       If required, change the surface chem spcs at the start of the 3D run
+          IF ( cs_surface_initial_change(1) /= 0.0_wp ) THEN            
+             DO lsp = 1, nspec 
+                chem_species(lsp)%conc(nzb,:,:) = chem_species(lsp)%conc(nzb,:,:) +  &
+                                                  cs_surface_initial_change(lsp)
+             ENDDO
+          ENDIF 
+!
+!--      Initiale old and new time levels. 
+          DO lsp = 1, nvar
+             chem_species(lsp)%tconc_m = 0.0_wp                      
+             chem_species(lsp)%conc_p  = chem_species(lsp)%conc     
+          ENDDO
+
+       ENDIF
+
+
+
+!---   new code add above this line
+       DO lsp = 1, nphot
+          phot_frequen(lsp)%name = phot_names(lsp)
+!         IF( myid == 0 )  THEN
+!            WRITE(6,'(a,i4,3x,a)')  'Photolysis: ',lsp,trim(phot_names(lsp))
+!         ENDIF 
+             phot_frequen(lsp)%freq(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => freq_1(:,:,:,lsp)
+       ENDDO
+
+       RETURN
+
+ END SUBROUTINE chem_init
+
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining initial vertical profiles of chemical species (given by
+!> namelist parameters chem_profiles and chem_heights)  --> which should work
+!> analogue to parameters u_profile, v_profile and uv_heights)
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_init_profiles              !< SUBROUTINE is called from chem_init in case of 
+                                               !< TRIM( initializing_actions ) /= 'read_restart_data'
+                                               !< We still need to see what has to be done in case of restart run
+       USE chem_modules
+
+       IMPLICIT NONE
+
+   !-- Local variables
+       INTEGER ::  lsp        !< running index for number of species in derived data type species_def
+       INTEGER ::  lsp_usr     !< running index for number of species (user defined)  in cs_names, cs_profiles etc
+       INTEGER ::  lpr_lev    !< running index for profile level for each chem spcs. 
+       INTEGER ::  npr_lev    !< the next available profile lev
+
+!-----------------
+!-- Parameter "cs_profile" and "cs_heights" are used to prescribe user defined initial profiles
+!-- and heights. If parameter "cs_profile" is not prescribed then initial surface values
+!-- "cs_surface" are used as constant initial profiles for each species. If "cs_profile" and
+!-- "cs_heights" are prescribed, their values will!override the constant profile given by
+!-- "cs_surface".
+! 
+       IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN 
+          lsp_usr = 1
+          DO  WHILE ( TRIM( cs_name( lsp_usr ) ) /= 'novalue' )   !'novalue' is the default
+             DO  lsp = 1, nspec                                !
+!--             create initial profile (conc_pr_init) for each chemical species
+                IF ( TRIM( chem_species(lsp)%name ) == TRIM( cs_name(lsp_usr) ) )  THEN   !
+                   IF ( cs_profile(lsp_usr,1) == 9999999.9_wp ) THEN
+!--                set a vertically constant profile based on the surface conc (cs_surface(lsp_usr)) of each species
+                      DO lpr_lev = 0, nzt+1
+                         chem_species(lsp)%conc_pr_init(lpr_lev) = cs_surface(lsp_usr)
+                      ENDDO
+                   ELSE
+                      IF ( cs_heights(1,1) /= 0.0_wp )  THEN
+                         message_string = 'The surface value of cs_heights must be 0.0'
+                         CALL message( 'chem_check_parameters', 'CM0434', 1, 2, 0, 6, 0 )
+                      ENDIF
+     
+                      use_prescribed_profile_data = .TRUE.
+    
+                      npr_lev = 1
+!                     chem_species(lsp)%conc_pr_init(0) = 0.0_wp
+                      DO  lpr_lev = 1, nz+1
+                         IF ( npr_lev < 100 )  THEN
+                            DO  WHILE ( cs_heights(lsp_usr, npr_lev+1) <= zu(lpr_lev) )
+                               npr_lev = npr_lev + 1
+                               IF ( npr_lev == 100 )  THEN
+                                   message_string = 'number of chem spcs exceeding the limit'
+                                   CALL message( 'chem_check_parameters', 'CM0435', 1, 2, 0, 6, 0 )               
+                                   EXIT
+                               ENDIF
+                            ENDDO
+                         ENDIF
+                         IF ( npr_lev < 100  .AND.  cs_heights(lsp_usr, npr_lev + 1) /= 9999999.9_wp )  THEN
+                            chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp_usr, npr_lev) +                          &
+                                                    ( zu(lpr_lev) - cs_heights(lsp_usr, npr_lev) ) /                          &
+                                                    ( cs_heights(lsp_usr, (npr_lev + 1)) - cs_heights(lsp_usr, npr_lev ) ) *  &
+                                                    ( cs_profile(lsp_usr, (npr_lev + 1)) - cs_profile(lsp_usr, npr_lev ) )
+                         ELSE
+                               chem_species(lsp)%conc_pr_init(lpr_lev) = cs_profile(lsp_usr, npr_lev)
+                         ENDIF
+                      ENDDO
+                   ENDIF
+!-- If a profile is prescribed explicity using cs_profiles and cs_heights, then  
+!-- chem_species(lsp)%conc_pr_init is populated with the specific "lsp" based
+!-- on the cs_profiles(lsp_usr,:)  and cs_heights(lsp_usr,:). 
+                ENDIF
+             ENDDO
+             lsp_usr = lsp_usr + 1
+          ENDDO
+       ENDIF
+
+    END SUBROUTINE chem_init_profiles
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine to integrate chemical species in the given chemical mechanism
+!------------------------------------------------------------------------------!
+
+    SUBROUTINE chem_integrate_ij (i, j)
+
+       USE cpulog,                                                              &
+          ONLY: cpu_log, log_point
+       USE statistics,                                                          &
+          ONLY:  weight_pres
+        USE control_parameters,                                                 &
+          ONLY:  dt_3d, intermediate_timestep_count,simulated_time
+
+       IMPLICIT   none
+       INTEGER,INTENT(IN)       :: i,j
+
+ !--   local variables
+       INTEGER(iwp) ::  lsp                                                     !< running index for chem spcs.
+       INTEGER(iwp) ::  lph                                                     !< running index for photolysis frequencies
+       INTEGER                  :: k,m,istatf
+       INTEGER,DIMENSION(20)    :: istatus
+       REAL(kind=wp),DIMENSION(nzb+1:nzt,nspec)                :: tmp_conc
+       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_temp
+       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_qvap
+       REAL(kind=wp),DIMENSION(nzb+1:nzt,nphot)                :: tmp_phot
+       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_fact
+       REAL(kind=wp),DIMENSION(nzb+1:nzt)                      :: tmp_fact_i    !< conversion factor between 
+                                                                                !<    molecules cm^{-3} and ppm
+
+       INTEGER,DIMENSION(nzb+1:nzt)                            :: nacc          !< Number of accepted steps
+       INTEGER,DIMENSION(nzb+1:nzt)                            :: nrej          !< Number of rejected steps
+
+       REAL(wp)                         ::  conv                                !< conversion factor
+       REAL(wp), PARAMETER              ::  ppm2fr  = 1.0e-6_wp                 !< Conversion factor ppm to fraction
+       REAL(wp), PARAMETER              ::  xm_air  = 28.96_wp                  !< Mole mass of dry air
+       REAL(wp), PARAMETER              ::  xm_h2o  = 18.01528_wp               !< Mole mass of water vapor
+       REAL(wp), PARAMETER              ::  pref_i  = 1._wp / 100000.0_wp       !< inverse reference pressure (1/Pa)
+       REAL(wp), PARAMETER              ::  t_std   = 273.15_wp                 !< standard pressure (Pa)
+       REAL(wp), PARAMETER              ::  p_std   = 101325.0_wp               !< standard pressure (Pa)
+       REAL(wp), PARAMETER              ::  vmolcm  = 22.414e3_wp               !< Mole volume (22.414 l) in cm^{-3}
+       REAL(wp), PARAMETER              ::  xna     = 6.022e23_wp               !< Avogadro number (molecules/mol)
+
+       REAL(wp),DIMENSION(size(rcntrl)) :: rcntrl_local
+
+
+       REAL(kind=wp)  :: dt_chem                                             
+
+       CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'start' )
+!<     set chem_gasphase_on to .FALSE. if you want to skip computation of gas phase chemistry
+       IF (chem_gasphase_on) THEN
+          nacc = 0
+          nrej = 0
+
+       tmp_temp(:) = pt(nzb+1:nzt,j,i) * exner(nzb+1:nzt)
+!         ppm to molecules/cm**3
+!         tmp_fact = 1.e-6_wp*6.022e23_wp/(22.414_wp*1000._wp) * 273.15_wp * hyp(nzb+1:nzt)/( 101300.0_wp * tmp_temp )  
+          conv = ppm2fr * xna / vmolcm
+          tmp_fact(:) = conv * t_std * hyp(nzb+1:nzt) / (tmp_temp(:) * p_std)
+          tmp_fact_i = 1.0_wp/tmp_fact
+
+          IF ( humidity ) THEN
+             IF ( bulk_cloud_model )  THEN
+                tmp_qvap(:) = ( q(nzb+1:nzt,j,i) - ql(nzb+1:nzt,j,i) ) * xm_air/xm_h2o * tmp_fact(:)
+             ELSE
+                tmp_qvap(:) = q(nzb+1:nzt,j,i) * xm_air/xm_h2o * tmp_fact(:)
+             ENDIF
+          ELSE
+             tmp_qvap(:) = 0.01 * tmp_fact(:)                          !< Constant value for q if water vapor is not computed
+          ENDIF
+
+          DO lsp = 1,nspec
+             tmp_conc(:,lsp) = chem_species(lsp)%conc(nzb+1:nzt,j,i) * tmp_fact(:) 
+          ENDDO
+
+          DO lph = 1,nphot
+             tmp_phot(:,lph) = phot_frequen(lph)%freq(nzb+1:nzt,j,i)               
+          ENDDO
+
+          IF(myid == 0 .AND. chem_debug0 ) THEN
+             IF (i == 10 .and. j == 10) WRITE(0,*) 'begin chemics step ',dt_3d
+          ENDIF
+
+!--       Compute length of time step
+          IF ( call_chem_at_all_substeps )  THEN
+             dt_chem = dt_3d * weight_pres(intermediate_timestep_count)
+          ELSE
+             dt_chem = dt_3d
+          ENDIF
+
+          cs_time_step = dt_chem
+
+          CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'start' )
+
+          IF(maxval(rcntrl) > 0.0)   THEN    ! Only if rcntrl is set
+             IF( simulated_time <= 2*dt_3d)  THEN
+                 rcntrl_local = 0
+                 WRITE(9,'(a,2f10.3)') 'USE Default rcntrl in the first steps ',simulated_time,dt_3d
+             ELSE
+                 rcntrl_local = rcntrl
+             ENDIF
+          ELSE
+             rcntrl_local = 0
+          END IF
+
+          CALL chem_gasphase_integrate (dt_chem, tmp_conc, tmp_temp, tmp_qvap, tmp_fact, tmp_phot, &
+                             icntrl_i = icntrl, rcntrl_i = rcntrl_local, xnacc = nacc, xnrej = nrej, istatus=istatus)
+
+          CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'stop' )
+
+          DO lsp = 1,nspec
+             chem_species(lsp)%conc (nzb+1:nzt,j,i) = tmp_conc(:,lsp) * tmp_fact_i(:)
+          ENDDO
+
+
+       ENDIF
+          CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'stop' )
+
+       RETURN
+    END SUBROUTINE chem_integrate_ij
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining parin for &chemistry_parameters for chemistry model
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_parin
+   
+       USE chem_modules
+       USE control_parameters
+      
+       USE kinds
+       USE pegrid
+       USE statistics
+           
+       IMPLICIT   NONE
+
+       CHARACTER (LEN=80) ::  line                        !< dummy string that contains the current line of the parameter file
+       CHARACTER (LEN=3)  ::  cs_prefix 
+
+       REAL(wp), DIMENSION(nmaxfixsteps) ::   my_steps    !< List of fixed timesteps   my_step(1) = 0.0 automatic stepping
+       INTEGER(iwp) ::  i                                 !< 
+       INTEGER(iwp) ::  j                                 !< 
+       INTEGER(iwp) ::  max_pr_cs_tmp                     !< 
+
+
+       NAMELIST /chemistry_parameters/  bc_cs_b,                          &
+                                        bc_cs_t,                          &
+                                        call_chem_at_all_substeps,        &
+                                        chem_debug0,                      &
+                                        chem_debug1,                      &
+                                        chem_debug2,                      &
+                                        chem_gasphase_on,                 &
+                                        cs_heights,                       &
+                                        cs_name,                          &
+                                        cs_profile,                       &
+                                        cs_profile_name,                  & 
+                                        cs_surface,                       &
+                                        decycle_chem_lr,                  &
+                                        decycle_chem_ns,                  &            
+                                        decycle_method,                   & 
+                                        emiss_factor_main,                &
+                                        emiss_factor_side,                &                      
+                                        icntrl,                           &
+                                        main_street_id,                   &
+                                        max_street_id,                    &
+                                        my_steps,                         &
+                                        nest_chemistry,                   &
+                                        rcntrl,                           &
+                                        side_street_id,                   &
+                                        photolysis_scheme,                &
+                                        wall_csflux,                      &
+                                        cs_vertical_gradient,             &
+                                        top_csflux,                       & 
+                                        surface_csflux,                   &
+                                        surface_csflux_name,              &
+                                        cs_surface_initial_change,        &
+                                        cs_vertical_gradient_level,       &
+!                                       namelist parameters for emissions
+                                        mode_emis,                        &
+                                        time_fac_type,                    &
+                                        daytype_mdh,                      &
+                                        do_emis                              
+                             
+!-- analogue to chem_names(nspj) we could invent chem_surfaceflux(nspj) and chem_topflux(nspj)
+!-- so this way we could prescribe a specific flux value for each species
+!>  chemistry_parameters for initial profiles
+!>  cs_names = 'O3', 'NO2', 'NO', ...   to set initial profiles)
+!>  cs_heights(1,:) = 0.0, 100.0, 500.0, 2000.0, .... (height levels where concs will be prescribed for O3)
+!>  cs_heights(2,:) = 0.0, 200.0, 400.0, 1000.0, .... (same for NO2 etc.) 
+!>  cs_profiles(1,:) = 10.0, 20.0, 20.0, 30.0, .....  (chem spcs conc at height lvls chem_heights(1,:)) etc.
+!>  If the respective concentration profile should be constant with height, then use "cs_surface( number of spcs)"
+!>  then write these cs_surface values to chem_species(lsp)%conc_pr_init(:)
+
+!
+!--   Read chem namelist   
+
+       INTEGER             :: ier
+       CHARACTER(LEN=64)   :: text
+       CHARACTER(LEN=8)    :: solver_type
+
+       icntrl    = 0
+       rcntrl    = 0.0_wp
+       my_steps  = 0.0_wp
+       photolysis_scheme = 'simple'
+       atol = 1.0_wp
+       rtol = 0.01_wp
+ !
+ !--   Try to find chemistry package
+       REWIND ( 11 )
+       line = ' '
+       DO   WHILE ( INDEX( line, '&chemistry_parameters' ) == 0 )
+          READ ( 11, '(A)', END=20 )  line
+       ENDDO
+       BACKSPACE ( 11 )
+ !
+ !--   Read chemistry namelist
+       READ ( 11, chemistry_parameters, ERR = 10, END = 20 )      
+ !
+ !--   Enable chemistry model
+       air_chemistry = .TRUE.                    
+      GOTO 20
+
+ 10   BACKSPACE( 11 )
+      READ( 11 , '(A)') line
+      CALL parin_fail_message( 'chemistry_parameters', line )
+
+ 20   CONTINUE
+
+!
+!--    check for  emission mode for chem species
+       IF ( (mode_emis /= 'PARAMETERIZED')  .AND. ( mode_emis /= 'DEFAULT') .AND. (mode_emis /= 'PRE-PROCESSED'  ) )   THEN
+            message_string = 'Incorrect mode_emiss  option select. Please check spelling'
+            CALL message( 'chem_check_parameters', 'CM0436', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       t_steps = my_steps          
+                                   
+!--    Determine the number of user-defined profiles and append them to the
+!--    standard data output (data_output_pr)
+       max_pr_cs_tmp = 0 
+       i = 1
+
+       DO  WHILE ( data_output_pr(i)  /= ' '  .AND.  i <= 100 )
+          IF ( TRIM( data_output_pr(i)(1:3)) == 'kc_' ) THEN
+             max_pr_cs_tmp = max_pr_cs_tmp+1
+          ENDIF
+          i = i +1
+       ENDDO
+
+       IF ( max_pr_cs_tmp > 0 ) THEN
+          cs_pr_namelist_found = .TRUE.
+          max_pr_cs = max_pr_cs_tmp
+       ENDIF
+
+!      Set Solver Type
+       IF(icntrl(3) == 0)   THEN
+          solver_type = 'rodas3'           !Default
+       ELSE IF(icntrl(3) == 1)   THEN
+          solver_type = 'ros2'
+       ELSE IF(icntrl(3) == 2)   THEN
+          solver_type = 'ros3'
+       ELSE IF(icntrl(3) == 3)   THEN
+          solver_type = 'ro4'
+       ELSE IF(icntrl(3) == 4)   THEN
+          solver_type = 'rodas3'
+       ELSE IF(icntrl(3) == 5)   THEN
+          solver_type = 'rodas4'
+       ELSE IF(icntrl(3) == 6)   THEN
+          solver_type = 'Rang3'
+       ELSE
+          IF(myid == 0)  write(0,*) 'illegal solver type '     !kk chane to PALM error message
+          call MPI_Abort (MPI_COMM_WORLD, 1, ier)
+       END IF
+
+       write(text,*) 'gas_phase chemistry: solver_type = ',trim(solver_type)
+!kk    Has to be changed to right calling sequence
+!kk       CALL location_message( trim(text), .FALSE. )
+       IF(myid == 0)   THEN
+          write(9,*) ' '
+          write(9,*) 'kpp setup '
+          write(9,*) ' '
+          write(9,*) '    gas_phase chemistry: solver_type = ',trim(solver_type)
+          write(9,*) ' '
+          write(9,*) '    Hstart  = ',rcntrl(3)
+          write(9,*) '    FacMin  = ',rcntrl(4)
+          write(9,*) '    FacMax  = ',rcntrl(5)
+          write(9,*) ' '
+          IF(vl_dim > 1)    THEN
+             write(9,*) '    Vector mode                   vektor length = ',vl_dim
+          ELSE
+             write(9,*) '    Scalar mode'
+          ENDIF
+          write(9,*) ' '
+       END IF
+
+       RETURN
+
+    END SUBROUTINE chem_parin
+
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine calculating prognostic equations for chemical species 
+!> (vector-optimized).
+!> Routine is called separately for each chemical species over a loop from
+!> prognostic_equations.
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_prognostic_equations ( cs_scalar_p, cs_scalar, tcs_scalar_m,  &
+                                           pr_init_cs, ilsp )
+
+       USE advec_s_pw_mod,                                                        &
+           ONLY:  advec_s_pw
+       USE advec_s_up_mod,                                                        &
+           ONLY:  advec_s_up
+       USE advec_ws,                                                              &
+           ONLY:  advec_s_ws 
+       USE diffusion_s_mod,                                                       &
+           ONLY:  diffusion_s
+       USE indices,                                                               &
+           ONLY:  nxl, nxr, nyn, nys, wall_flags_0
+       USE pegrid
+       USE surface_mod,                                                           &
+           ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
+                  surf_usm_v
+
+       IMPLICIT NONE
+
+       INTEGER ::  i   !< running index
+       INTEGER ::  j   !< running index
+       INTEGER ::  k   !< running index
+
+       INTEGER(iwp),INTENT(IN) ::  ilsp          !<
+
+       REAL(wp), DIMENSION(0:nz+1) ::  pr_init_cs   !<
+
+       REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar      !<
+       REAL(wp), DIMENSION(:,:,:), POINTER ::  cs_scalar_p    !<
+       REAL(wp), DIMENSION(:,:,:), POINTER ::  tcs_scalar_m   !<
+
+
+   !
+   !-- Tendency terms for chemical species
+       tend = 0.0_wp
+   !    
+   !-- Advection terms
+       IF ( timestep_scheme(1:5) == 'runge' )  THEN
+          IF ( ws_scheme_sca )  THEN
+             CALL advec_s_ws( cs_scalar, 'kc' )
+          ELSE
+             CALL advec_s_pw( cs_scalar )
+          ENDIF
+       ELSE
+            CALL advec_s_up( cs_scalar )
+       ENDIF
+   !
+   !-- Diffusion terms  (the last three arguments are zero)
+       CALL diffusion_s( cs_scalar,                                               &
+                         surf_def_h(0)%cssws(ilsp,:),                             &
+                         surf_def_h(1)%cssws(ilsp,:),                             &
+                         surf_def_h(2)%cssws(ilsp,:),                             &
+                         surf_lsm_h%cssws(ilsp,:),                                &
+                         surf_usm_h%cssws(ilsp,:),                                &
+                         surf_def_v(0)%cssws(ilsp,:),                             &
+                         surf_def_v(1)%cssws(ilsp,:),                             &
+                         surf_def_v(2)%cssws(ilsp,:),                             &
+                         surf_def_v(3)%cssws(ilsp,:),                             &
+                         surf_lsm_v(0)%cssws(ilsp,:),                             &
+                         surf_lsm_v(1)%cssws(ilsp,:),                             &
+                         surf_lsm_v(2)%cssws(ilsp,:),                             &
+                         surf_lsm_v(3)%cssws(ilsp,:),                             &
+                         surf_usm_v(0)%cssws(ilsp,:),                             &
+                         surf_usm_v(1)%cssws(ilsp,:),                             &
+                         surf_usm_v(2)%cssws(ilsp,:),                             &
+                         surf_usm_v(3)%cssws(ilsp,:) )
+   !    
+   !-- Prognostic equation for chemical species
+       DO  i = nxl, nxr
+          DO  j = nys, nyn    
+             DO  k = nzb+1, nzt
+                cs_scalar_p(k,j,i) =   cs_scalar(k,j,i)                           &
+                                     + ( dt_3d  *                                 &
+                                         (   tsc(2) * tend(k,j,i)                 &
+                                           + tsc(3) * tcs_scalar_m(k,j,i)         &
+                                         )                                        & 
+                                       - tsc(5) * rdf_sc(k)                       &
+                                                * ( cs_scalar(k,j,i) - pr_init_cs(k) )    &   
+                                       )                                          &
+                                       * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )       
+
+                IF ( cs_scalar_p(k,j,i) < 0.0_wp )  cs_scalar_p(k,j,i) = 0.1_wp * cs_scalar(k,j,i)
+             ENDDO
+          ENDDO
+       ENDDO
+   !
+   !-- Calculate tendencies for the next Runge-Kutta step
+       IF ( timestep_scheme(1:5) == 'runge' )  THEN
+          IF ( intermediate_timestep_count == 1 )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn   
+                   DO  k = nzb+1, nzt
+                      tcs_scalar_m(k,j,i) = tend(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSEIF ( intermediate_timestep_count < &
+             intermediate_timestep_count_max )  THEN
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   match_def = surf_def_h(0)%start_index(j,i) <=               &
-                               surf_def_h(0)%end_index(j,i)
-                   match_lsm = surf_lsm_h%start_index(j,i) <=                  &
-                               surf_lsm_h%end_index(j,i)
-                   match_usm = surf_usm_h%start_index(j,i) <=                  &
-                               surf_usm_h%end_index(j,i)
-
-                   IF ( match_def )  THEN
-                      m = surf_def_h(0)%end_index(j,i)
-                      chem_species(lsp)%cssws_av(j,i) =                        &
-                                             chem_species(lsp)%cssws_av(j,i) + &
-                                             surf_def_h(0)%cssws(lsp,m)
-                   ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                      m = surf_lsm_h%end_index(j,i)
-                      chem_species(lsp)%cssws_av(j,i) =                        &
-                                             chem_species(lsp)%cssws_av(j,i) + &
-                                             surf_lsm_h%cssws(lsp,m)
-                   ELSEIF ( match_usm )  THEN
-                      m = surf_usm_h%end_index(j,i)
-                      chem_species(lsp)%cssws_av(j,i) =                        &
-                                             chem_species(lsp)%cssws_av(j,i) + &
-                                             surf_usm_h%cssws(lsp,m)
-                   ENDIF
+                   DO  k = nzb+1, nzt
+                      tcs_scalar_m(k,j,i) = - 9.5625_wp * tend(k,j,i)             &
+                                            + 5.3125_wp * tcs_scalar_m(k,j,i)
+                   ENDDO
                 ENDDO
              ENDDO
           ENDIF
-       ENDDO
- 
-    ELSEIF ( mode == 'average' )  THEN
-       DO lsp = 1, nspec
-          IF (TRIM(variable(4:)) == TRIM(chem_species(lsp)%name)) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                       chem_species(lsp)%conc_av(k,j,i) = chem_species(lsp)%conc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          ELSEIF (TRIM(variable(4:)) == TRIM('cssws*') )            THEN
-             DO i = nxlg, nxrg
-                DO  j = nysg, nyng
-                     chem_species(lsp)%cssws_av(j,i) = chem_species(lsp)%cssws_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-                CALL exchange_horiz_2d( chem_species(lsp)%cssws_av, nbgp )                 
-          ENDIF
-       ENDDO
-       
-    ENDIF     
-
-    END SUBROUTINE chem_3d_data_averaging
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine to write restart data for chemistry model
-!------------------------------------------------------------------------------!
- SUBROUTINE chem_wrd_local
-
-
-    IMPLICIT NONE 
-
-    INTEGER(iwp) ::  lsp !< 
-
-!      REAL(kind=wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg)   :: chems_conc
-
-
-    DO  lsp = 1, nspec
-
-       CALL wrd_write_string( TRIM( chem_species(lsp)%name ))
-       WRITE ( 14 )  chem_species(lsp)%conc
-
-       CALL wrd_write_string( TRIM( chem_species(lsp)%name )//'_av' )
-       WRITE ( 14 )  chem_species(lsp)%conc_av
-
-    ENDDO
-
-
- END SUBROUTINE chem_wrd_local
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine to read restart data of chemical species
-!------------------------------------------------------------------------------!
-
- SUBROUTINE chem_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,         &
-                            nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,  &
-                            nys_on_file, tmp_3d, found )    
-                                     
-    USE control_parameters
-            
-    USE indices
-    
-    USE pegrid
-
-    IMPLICIT NONE 
-
-    CHARACTER (LEN=20) :: spc_name_av !<   
-       
-    INTEGER(iwp) ::  i, lsp          !< 
-    INTEGER(iwp) ::  k               !< 
-    INTEGER(iwp) ::  nxlc            !< 
-    INTEGER(iwp) ::  nxlf            !< 
-    INTEGER(iwp) ::  nxl_on_file     !<   
-    INTEGER(iwp) ::  nxrc            !< 
-    INTEGER(iwp) ::  nxrf            !< 
-    INTEGER(iwp) ::  nxr_on_file     !<   
-    INTEGER(iwp) ::  nync            !< 
-    INTEGER(iwp) ::  nynf            !< 
-    INTEGER(iwp) ::  nyn_on_file     !<   
-    INTEGER(iwp) ::  nysc            !< 
-    INTEGER(iwp) ::  nysf            !< 
-    INTEGER(iwp) ::  nys_on_file     !<   
-    
-    LOGICAL, INTENT(OUT)  :: found 
-
-    REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !< 3D array to temp store data
-
-
-    found = .FALSE.  
-
-
-       IF ( ALLOCATED(chem_species) )  THEN
-
-          DO  lsp = 1, nspec
-
-              !< for time-averaged chemical conc.
-             spc_name_av  =  TRIM(chem_species(lsp)%name)//'_av'
-
-             IF (restart_string(1:length) == TRIM(chem_species(lsp)%name) )    &
-             THEN
-                !< read data into tmp_3d
-                IF ( k == 1 )  READ ( 13 )  tmp_3d  
-                !< fill ..%conc in the restart run    
-                chem_species(lsp)%conc(:,nysc-nbgp:nync+nbgp,                  &
-                                       nxlc-nbgp:nxrc+nbgp) =                  & 
-                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                found = .TRUE.
-             ELSEIF (restart_string(1:length) == spc_name_av )  THEN
-                IF ( k == 1 )  READ ( 13 )  tmp_3d
-                chem_species(lsp)%conc_av(:,nysc-nbgp:nync+nbgp,               &
-                                          nxlc-nbgp:nxrc+nbgp) =               &
-                tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                found = .TRUE.
-             ENDIF
-
-          ENDDO
-
        ENDIF
 
-
- END SUBROUTINE chem_rrd_local
-
+    END SUBROUTINE chem_prognostic_equations
 
 !------------------------------------------------------------------------------!
